SystemOrganization addCategory: #'ObjectDiff-OD'!
SystemOrganization addCategory: #'ObjectDiff-OD-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-GUI'!

TestCase subclass: #ODSheetTest
	instanceVariableNames: 'sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-Test'!

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:34'!
setUp
super setUp.
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt1At1
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 1) equals: 9! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:31'!
testValueAt1At2
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 2) equals: 'ByteString'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:29'!
testValueAt1At3
self assert: ((sheet valueOfObjectAt: 1 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt2At1
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 1) equals: 0! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt2At2
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 2) equals: 'SmallInteger'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt2At3
self deny: (sheet valueOfObjectAt: 2 byAccessAt: 3).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt3At1
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 1) equals: 52! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:37'!
testValueAt3At2
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 2) equals: 'PasteUpMorph'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt3At3
self assert: ((sheet valueOfObjectAt: 3 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

TestCase subclass: #ODiffyArrayArrayTest
	instanceVariableNames: 'array1 array2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:08'!
setUp
|o|
super setUp.
o := 1@2.
array1 := Array with: 1 with: 3 with: 3/4 with: (o extent: 7@8).
array2 := Array with: 3 with: 3 with: 3/4 with: (o extent: 7@7).! !

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:15'!
testArray
|d e|
d := OArrayDiffy new.
d leftSideObject: array1.
d rightSideObject: array2.
e := d elementDiffies.
self assert: e size equals: 4.
(e at: 1) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].
(e at: 2) ifIdentical: [] ifEqual: [self fail]  ifDifferent: [self fail].
(e at: 3) ifIdentical: [self fail] ifEqual: []  ifDifferent: [self fail].
(e at: 4) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].! !

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:15'!
testArrayAt4
|d e r|
d := OArrayDiffy new.
d leftSideObject: array1.
d rightSideObject: array2.
e := d elementDiffies.
r := (e at: 4) diffies.
self assert: r size equals: 2.
self assert: ((r at: 1) instVarName) equals: 'origin'.
(r at: 1) ifIdentical: [] ifEqual: [self fail]  ifDifferent: [self fail].
self assert: ((r at: 2) instVarName) equals: 'corner'.
(r at: 2) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].
! !

TestCase subclass: #ODiffyIVarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyIVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:38'!
test2Rects
|d o r1 r2 i |
o := 1@2.
r1 := o extent: 3@4.
r2 := o extent: 3@3.
d:=ODiffy new.
d leftSideObject: r1.
d rightSideObject: r2.
i := d ivarDiffies.
self assert: i size equals: 2.
self assert: 'origin' equals: (i at: 1) instVarName.
self assert: 'corner' equals: (i at: 2) instVarName.

(i at: 1) ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].
(i at: 2) ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyIVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:03'!
test2RectsAgain
|d o r1 r2 i |
o := 1@2.
r1 := o extent: 3@4.
r2 := o extent: 3@3.
d:=ODiffy new.
d leftSideObject: r1.
d rightSideObject: r2.
i := (d ivarDiffies at: 2) ivarDiffies.
self assert: i size equals: 2.
self assert: 'x' equals: (i at: 1) instVarName.
(i at: 1) ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].
self assert: 'y' equals: (i at: 2) instVarName.
(i at: 2) ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].
! !

TestCase subclass: #ODiffyObjectObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:25'!
testDifferent

	|d|
	d := ODiffy new.
	d leftSideObject: (3@4 extent: 1@2).
	d rightSideObject: (1@2 extent: 10@5).
	d ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:24'!
testEqual

	|d|
	d := ODiffy new.
	d leftSideObject: (1@2 extent: 3@4).
	d rightSideObject: (1@2 extent: 3@4).
	d ifIdentical: [self fail] ifEqual: [] ifDifferent: [self fail].! !

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:26'!
testIdentical

	|d r|
	r := 1@2 extent: 3@4.
	d := ODiffy new.
	d leftSideObject: r.
	d rightSideObject: r.
	d ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].! !

TestCase subclass: #ODiffyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:20'!
testDifferent

	|d|
	d := ODiffy new.
	d leftSideObject: 3.
	d rightSideObject: 4.
	d ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:21'!
testEqual

	|d|
	d := ODiffy new.
	d leftSideObject: 3/4.
	d rightSideObject: 3/4.
	d ifIdentical: [self fail] ifEqual: [] ifDifferent: [self fail].! !

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:19'!
testIdentical

	|d|
	d := ODiffy new.
	d leftSideObject: 3.
	d rightSideObject: 3.
	d ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].! !

TestCase subclass: #OIvarReferenceTest
	instanceVariableNames: 'rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:48'!
setUp
super setUp.
rectangle := 1@2 corner: 10@20.! !

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:54'!
testCorner

self assert: ((OIvarReference object: rectangle instVarName: 'corner')
			value)
	equals: rectangle corner.! !

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:52'!
testOrigin

self assert: ((OIvarReference object: rectangle instVarName: 'origin')
			value)
	equals: rectangle origin.! !

Object subclass: #OArrayDiffy
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:14'!
elementDiffies
^(1 to: leftSideObject size)
	collect: 
		[:key|
		ODiffy new
			leftSideObject: (leftSideObject at: key);
			rightSideObject: (rightSideObject at: key)
		]! !

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:10'!
leftSideObject: anObject 
leftSideObject:= anObject ! !

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:10'!
rightSideObject: anObject 

rightSideObject:= anObject! !

Object subclass: #ODAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

Object subclass: #ODSheet
	instanceVariableNames: 'objects accesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses
	^ accesses! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses: anArray
	accesses := anArray
! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects
	^ objects! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects: anArray
	objects := anArray
! !

!ODSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:25'!
valueOfObjectAt: objectIndex byAccessAt: accessIndex
|object access|
object := objects at: objectIndex.
access := accesses at: accessIndex.
^[access value: object] on: Error do: [:ex| ex]
! !

Object subclass: #ODWorkspace
	instanceVariableNames: 'sheet cellExtent contents win'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-GUI'!

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:19'!
cellMorphAtRow: rowIndex atColumn: colIndex
|cellObject morph|
cellObject := 
rowIndex = 0
	ifTrue: 
		[colIndex = 0
			ifTrue: ['objects'] 
			ifFalse: [sheet accesses at: colIndex]]
	ifFalse: 
		[colIndex = 0
			ifTrue: [sheet objects at: rowIndex]
			ifFalse: [sheet valueOfObjectAt: rowIndex byAccessAt: colIndex]].
morph := cellObject printString asMorph.
morph extent: cellExtent.
^morph! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:53'!
construct

self makeSheet.

cellExtent := 200@40.

contents := 
UITheme builder newColumn: 
	(Array streamContents: 
		[:rowStream|	
		0 to: sheet objects size do: 
			[:objectIndex|
			rowStream nextPut: 
				(UITheme builder newRow: 
					(Array streamContents: 
						[:stream|
						0 to: sheet accesses size do: 
							[:accessIndex|
							stream nextPut: (self cellMorphAtRow: objectIndex  atColumn: accessIndex)
							]
						])).
			]
]).! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 15:24'!
makeSheet
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

Object subclass: #ODiffy
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:12'!
diffies
^self ivarDiffies! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:56'!
ifIdentical: iBlock ifEqual: eBlock ifDifferent: dBlock
^leftSideObject == rightSideObject
	ifTrue: iBlock
	ifFalse: 
		[leftSideObject = rightSideObject
			ifTrue: eBlock
			ifFalse: dBlock]! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:57'!
instVarName
	(leftSideObject respondsTo: #instVarName) ifFalse: [self error: ''].
	(rightSideObject respondsTo: #instVarName) ifFalse: [self error: ''].
	(leftSideObject instVarName = rightSideObject instVarName) ifFalse: [self error: ''].
	^leftSideObject instVarName! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:33'!
ivarDiffies
^leftSideObject class instVarNames
	collect: 
		[:iName|
			OIVarDiffy new
				leftSideObject: leftSideObject;
				rightSideObject: rightSideObject;
				instVarName: iName]! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:59'!
ivarDiffies100
^leftSideObject class instVarNames
	collect: 
		[:iName|
			ODiffy new
				leftSideObject: (OIvarReference object: leftSideObject instVarName: iName);
				rightSideObject: (OIvarReference object: rightSideObject instVarName: iName)]! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
leftSideObject
	^ leftSideObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
leftSideObject: anObject
	leftSideObject := anObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
rightSideObject
	^ rightSideObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
rightSideObject: anObject
	rightSideObject := anObject! !

Object subclass: #OIVarDiffy
	instanceVariableNames: 'instVarName leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:01'!
ifIdentical: iBlock ifEqual: eBlock ifDifferent: dBlock
|i1 i2|
i1 := self leftSideValue.
i2 := self rightSideValue.
^i1 == i2
	ifTrue: iBlock
	ifFalse: 
		[i1 = i2
			ifTrue: eBlock
			ifFalse: dBlock]! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:36'!
instVarName
	^ instVarName! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:35'!
instVarName: aString 
	instVarName := aString! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:02'!
ivarDiffies
^(self leftSideValue) class instVarNames
	collect: 
		[:iName|
			OIVarDiffy new
				leftSideObject: (self leftSideValue);
				rightSideObject: (self rightSideValue);
				instVarName: iName]! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:34'!
leftSideObject: anObject 
	leftSideObject := anObject! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:00'!
leftSideValue.
^leftSideObject instVarAt: (leftSideObject class instVarNames indexOf: instVarName)! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:35'!
rightSideObject: anObject 
	rightSideObject := anObject! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:01'!
rightSideValue.
^rightSideObject instVarAt: (rightSideObject class instVarNames indexOf: instVarName)! !

Object subclass: #OIvarReference
	instanceVariableNames: 'object instVarName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OIvarReference classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:53'!
object: anObject instVarName: aString 

^self new
	object: anObject;
	instVarName: aString;
	yourself! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
instVarName
	^ instVarName! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
instVarName: aString
	instVarName := aString
! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
object
	^ object! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
object: anObject
	object := anObject! !

!OIvarReference methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:50'!
value

	^object instVarAt: (object class instVarNames indexOf: instVarName)! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/3/2012 10:48'!
diff: anObject 
|obj1 obj2 pr|
obj1 := self.
obj2 := anObject.

pr:= [:obj| obj className, String cr, (obj longPrintStringLimitedTo: 20000)].
(DiffMorph new from: (pr value:obj1) to: (pr value:obj2)) openInWindowLabeled: obj1 printString, ' vs ', obj2 printString.
! !
